<!-- Do not edit this file. It is automatically generated by API Documenter. -->

[Home](./index.md) &gt; [kibana-plugin-public](./kibana-plugin-public.md) &gt; [ApplicationSetup](./kibana-plugin-public.applicationsetup.md) &gt; [registerAppUpdater](./kibana-plugin-public.applicationsetup.registerappupdater.md)

## ApplicationSetup.registerAppUpdater() method

Register an application updater that can be used to change the [AppUpdatableFields](./kibana-plugin-public.appupdatablefields.md) fields of all applications at runtime.

This is meant to be used by plugins that needs to updates the whole list of applications. To only updates a specific application, use the `updater$` property of the registered application instead.

<b>Signature:</b>

```typescript
registerAppUpdater(appUpdater$: Observable<AppUpdater>): void;
```

## Parameters

|  Parameter | Type | Description |
|  --- | --- | --- |
|  appUpdater$ | <code>Observable&lt;AppUpdater&gt;</code> |  |

<b>Returns:</b>

`void`

## Example

How to register an application updater that disables some applications:

```ts
// inside your plugin's setup function
export class MyPlugin implements Plugin {
  setup({ application }) {
    application.registerAppUpdater(
      new BehaviorSubject<AppUpdater>(app => {
         if (myPluginApi.shouldDisable(app))
           return {
             status: AppStatus.inaccessible,
           };
       })
     );
    }
}

```

