<!-- Do not edit this file. It is automatically generated by API Documenter. -->

[Home](./index.md) &gt; [kibana-plugin-public](./kibana-plugin-public.md) &gt; [ChromeStart](./kibana-plugin-public.chromestart.md)

## ChromeStart interface

ChromeStart allows plugins to customize the global chrome header UI and enrich the UX with additional information about the current location of the browser.

<b>Signature:</b>

```typescript
export interface ChromeStart 
```

## Remarks

While ChromeStart exposes many APIs, they should be used sparingly and the developer should understand how they affect other plugins and applications.

## Example 1

How to add a recently accessed item to the sidebar:

```ts
core.chrome.recentlyAccessed.add('/app/map/1234', 'Map 1234', '1234');

```

## Example 2

How to set the help dropdown extension:

```tsx
core.chrome.setHelpExtension(elem => {
  ReactDOM.render(<MyHelpComponent />, elem);
  return () => ReactDOM.unmountComponentAtNode(elem);
});

```

## Properties

|  Property | Type | Description |
|  --- | --- | --- |
|  [docTitle](./kibana-plugin-public.chromestart.doctitle.md) | <code>ChromeDocTitle</code> | APIs for accessing and updating the document title. |
|  [navControls](./kibana-plugin-public.chromestart.navcontrols.md) | <code>ChromeNavControls</code> | [APIs](./kibana-plugin-public.chromenavcontrols.md) for registering new controls to be displayed in the navigation bar. |
|  [navLinks](./kibana-plugin-public.chromestart.navlinks.md) | <code>ChromeNavLinks</code> | [APIs](./kibana-plugin-public.chromenavlinks.md) for manipulating nav links. |
|  [recentlyAccessed](./kibana-plugin-public.chromestart.recentlyaccessed.md) | <code>ChromeRecentlyAccessed</code> | [APIs](./kibana-plugin-public.chromerecentlyaccessed.md) for recently accessed history. |

## Methods

|  Method | Description |
|  --- | --- |
|  [addApplicationClass(className)](./kibana-plugin-public.chromestart.addapplicationclass.md) | Add a className that should be set on the application container. |
|  [getApplicationClasses$()](./kibana-plugin-public.chromestart.getapplicationclasses_.md) | Get the current set of classNames that will be set on the application container. |
|  [getBadge$()](./kibana-plugin-public.chromestart.getbadge_.md) | Get an observable of the current badge |
|  [getBrand$()](./kibana-plugin-public.chromestart.getbrand_.md) | Get an observable of the current brand information. |
|  [getBreadcrumbs$()](./kibana-plugin-public.chromestart.getbreadcrumbs_.md) | Get an observable of the current list of breadcrumbs |
|  [getHelpExtension$()](./kibana-plugin-public.chromestart.gethelpextension_.md) | Get an observable of the current custom help conttent |
|  [getIsCollapsed$()](./kibana-plugin-public.chromestart.getiscollapsed_.md) | Get an observable of the current collapsed state of the chrome. |
|  [getIsVisible$()](./kibana-plugin-public.chromestart.getisvisible_.md) | Get an observable of the current visibility state of the chrome. |
|  [removeApplicationClass(className)](./kibana-plugin-public.chromestart.removeapplicationclass.md) | Remove a className added with <code>addApplicationClass()</code>. If className is unknown it is ignored. |
|  [setAppTitle(appTitle)](./kibana-plugin-public.chromestart.setapptitle.md) | Sets the current app's title |
|  [setBadge(badge)](./kibana-plugin-public.chromestart.setbadge.md) | Override the current badge |
|  [setBrand(brand)](./kibana-plugin-public.chromestart.setbrand.md) | Set the brand configuration. |
|  [setBreadcrumbs(newBreadcrumbs)](./kibana-plugin-public.chromestart.setbreadcrumbs.md) | Override the current set of breadcrumbs |
|  [setHelpExtension(helpExtension)](./kibana-plugin-public.chromestart.sethelpextension.md) | Override the current set of custom help content |
|  [setHelpSupportUrl(url)](./kibana-plugin-public.chromestart.sethelpsupporturl.md) | Override the default support URL shown in the help menu |
|  [setIsCollapsed(isCollapsed)](./kibana-plugin-public.chromestart.setiscollapsed.md) | Set the collapsed state of the chrome navigation. |
|  [setIsVisible(isVisible)](./kibana-plugin-public.chromestart.setisvisible.md) | Set the temporary visibility for the chrome. This does nothing if the chrome is hidden by default and should be used to hide the chrome for things like full-screen modes with an exit button. |

